package com.flywithu.carnav;

import android.app.AlarmManager;
import android.app.Application;
import android.app.Notification;
import android.app.NotificationChannel;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.Service;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.hardware.usb.UsbDeviceConnection;
import android.hardware.usb.UsbManager;
import android.media.RingtoneManager;
import android.net.Uri;
import android.os.Build;
import android.os.Handler;
import android.os.IBinder;

import android.util.Log;
import android.widget.Toast;

import androidx.core.app.NotificationCompat;

import com.hoho.android.usbserial.driver.UsbSerialDriver;
import com.hoho.android.usbserial.driver.UsbSerialPort;
import com.hoho.android.usbserial.driver.UsbSerialProber;

import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class RealService extends Service {
    //   private Thread mainThread;
    public static Intent serviceIntent = null;

    private static UsbSerialPort sPort = null;


    public RealService() {
    }

    private void sendSerial(String str) {
        byte t1[] = new byte[]{0x55, 0x34, 0x50, 0x4C, 0x30, 0x33, 0x7C, 0x31, 0x2C, 0x31, 0x7C, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30, 0x30};
        byte t2[] = new byte[]{0x55, 0x34, 0x50, 0x4C, 0x31, 0x33, 0x7C, 0x41, (byte) 0xec, (byte) 0xa7, (byte) 0x80, (byte) 0xec, (byte) 0x96, (byte) 0xb4, (byte) 0xeb, (byte) 0xb0, (byte) 0x98, 0x5a, 0x7c};
        byte t3[] = new byte[]{0x55, 0x34, 0x50, 0x4C, 0x32, 0x33, 0x7C, (byte) 0xfe, (byte) 0xff, 0x00, 0x41, (byte) 0xc9, (byte) 0xc0, (byte) 0xc5, (byte) 0xb4, (byte) 0xbc, 0x18, 0x00, 0x5a, 0x7c};
        byte t4[] = new byte[]{0x55, 0x34, 0x50, 0x4C, 0x33, 0x33, 0x7C, 0x00, 0x00, 0x00, 0x41, 0x00, 0x00, (byte) 0xc9, (byte) 0xc0, 0x00, 0x00, (byte) 0xc5, (byte) 0xb4, 0x00, 0x00, (byte) 0xbc, 0x18, 0x00, 0x00, 0x00, 0x5a, 0x7c};
        /*
        41eca780ec96b4ebb0985a
feff0041c9c0c5b4bc18005a
000000410000c9c00000c5b40000bc180000005a
         */
        if (sPort != null) {
            try {
                //   sPort.write(str.getBytes(), 3000);
                sPort.write(t1, 3000);
                sPort.write(new byte[]{0xd}, 3000);

                sPort.write(t2, 3000);
                sPort.write(new byte[]{0xd}, 3000);

                sPort.write(t3, 3000);
                sPort.write(new byte[]{0xd}, 3000);

                sPort.write(t4, 3000);
                sPort.write(new byte[]{0xd}, 3000);
            } catch (Exception e) {

            }

        }

    }

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) {
        serviceIntent = intent;
        showToast(getApplication(), "Start Service");

//
//        mainThread = new Thread(new Runnable() {
//            @Override
//            public void run() {


        UsbManager manager = (UsbManager) getSystemService(Context.USB_SERVICE);
        List<UsbSerialDriver> availableDrivers = UsbSerialProber.getDefaultProber().findAllDrivers(manager);
        if (availableDrivers.isEmpty()) {
            showToast(getApplication(), "NO SERIAL");
            return START_NOT_STICKY;
        }

// Open a connection to the first available driver.
        UsbSerialDriver driver = null;
        UsbDeviceConnection connection = null;
        try {
            driver = availableDrivers.get(0);
            connection = manager.openDevice(driver.getDevice());
            if (connection == null) {
                showToast(getApplication(), "No connection");
                // You probably need to call UsbManager.requestPermission(driver.getDevice(), ..)
                return START_NOT_STICKY;
            }
        } catch (Exception e) {
            showToast(getApplication(), e.toString());
        }

        try {
            sPort.open(connection);
            sPort.setParameters(19200, 8, UsbSerialPort.STOPBITS_1, UsbSerialPort.PARITY_NONE);


        } catch (IOException e) {
            showToast(getApplication(), "Error opening device: " + e.getMessage());
            try {
                sPort.close();
            } catch (IOException e2) {
                // Ignore.
            }
            sPort = null;
        }
        //set the time
        //TMST001801140907
        //TMST00YYDDDD0907
        //TMST001205010916
        SimpleDateFormat format1 = new SimpleDateFormat("00yyMMddHHmm");
        //   String f = format1.format(System.currentTimeMillis());
        String currentInfo = format1.format(new Date());
        String currentTime = String.format("TMST%s", currentInfo);
        sendSerial(currentTime);
        sendSerial("U4EN00");
        sendSerial("*R|R1R2R3D1D2A1A3U4|");
        sendSerial("U4PL03|5,3|0001010000000");
        sendSerial("U4PL13|soar| U4PL23|헤어지자 (Prod. 정키)|");
        sendSerial("U4PL33|휘인 (Whee In)|");


//        sendSerial("U4DI00");
//        sendSerial("*R|R1R2R3D1D2A1A3|");
//        U4EN00
//                *R|R1R2R3D1D2A1A3U4|
//                A1PL00


        //U4PL03|1,1|0001010000000 U4PL13|soar| U4PL23|헤어지자 (Prod. 정키)| U4PL33|휘인 (Whee In)|

        showToast(getApplication(), currentTime);

//                try {
//                    sPort.write("zxcv".getBytes(), 50);
//                }
//                catch(Exception e)
//                {
//
//                }
//                SimpleDateFormat sdf = new SimpleDateFormat("aa hh:mm");
//                boolean run = true;
//                while (run) {
//                    try {
//                        Thread.sleep(1000 * 60 * 1); // 1 minute
//                        Date date = new Date();
//                        //showToast(getApplication(), sdf.format(date));
//                        sendNotification(sdf.format(date));
//                    } catch (InterruptedException e) {
//                        run = false;
//                        e.printStackTrace();
//                    }
//                }
//            }
//        });
//        mainThread.start();
        IntentFilter iF = new IntentFilter();
        iF.addAction("com.android.music.metachanged");

        iF.addAction("com.htc.music.metachanged");

        iF.addAction("fm.last.android.metachanged");
        iF.addAction("com.sec.android.app.music.metachanged");
        iF.addAction("com.nullsoft.winamp.metachanged");
        iF.addAction("com.amazon.mp3.metachanged");
        iF.addAction("com.miui.player.metachanged");
        iF.addAction("com.real.IMP.metachanged");
        iF.addAction("com.sonyericsson.music.metachanged");
        iF.addAction("com.rdio.android.metachanged");
        iF.addAction("com.samsung.sec.android.MusicPlayer.metachanged");
        iF.addAction("com.andrew.apollo.metachanged");

        registerReceiver(mReceiver, iF);
        return START_NOT_STICKY;
    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        try {
            sPort.close();
            sPort = null;
        } catch (Exception e) {

        }
        serviceIntent = null;
        setAlarmTimer();
        Thread.currentThread().interrupt();

//        if (mainThread != null) {
//            mainThread.interrupt();
//            mainThread = null;
//        }
    }

    @Override
    public void onCreate() {
        super.onCreate();
    }

    @Override
    public IBinder onBind(Intent intent) {
        return null;
    }

    @Override
    public boolean onUnbind(Intent intent) {
        return super.onUnbind(intent);
    }

    public void showToast(final Application application, final String msg) {
        Handler h = new Handler(application.getMainLooper());
        h.post(new Runnable() {
            @Override
            public void run() {
                Toast.makeText(application, msg, Toast.LENGTH_LONG).show();
            }
        });
    }

    protected void setAlarmTimer() {
        final Calendar c = Calendar.getInstance();
        c.setTimeInMillis(System.currentTimeMillis());
        c.add(Calendar.SECOND, 1);
        Intent intent = new Intent(this, AlarmRecever.class);
        PendingIntent sender = PendingIntent.getBroadcast(this, 0, intent, 0);

        AlarmManager mAlarmManager = (AlarmManager) getSystemService(Context.ALARM_SERVICE);
        mAlarmManager.set(AlarmManager.RTC_WAKEUP, c.getTimeInMillis(), sender);
    }


    private BroadcastReceiver mReceiver = new BroadcastReceiver() {

        @Override
        public void onReceive(Context context, Intent intent) {
            try {
                if (sPort != null) {
                    sPort.write("abc".getBytes(), 3000);
                }
            } catch (Exception e) {
                e.toString();
            }
            String action = intent.getAction();
            String cmd = intent.getStringExtra("command");
            Log.v("tag ", action + " / " + cmd);
            String artist = intent.getStringExtra("artist");
            String album = intent.getStringExtra("album");
            String track = intent.getStringExtra("track");
            Log.v("tag", artist + ":" + album + ":" + track);


            //    Toast.makeText(MainActivity.this, track, Toast.LENGTH_SHORT).show();
        }
    };


//    private void sendNotification(String messageBody) {
//        Intent intent = new Intent(this, MainActivity.class);
//        intent.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP);
//        PendingIntent pendingIntent = PendingIntent.getActivity(this, 0 /* Request code */, intent, PendingIntent.FLAG_ONE_SHOT);
//
//        String channelId = "fcm_default_channel";//getString(R.string.default_notification_channel_id);
//        Uri defaultSoundUri= RingtoneManager.getDefaultUri(RingtoneManager.TYPE_NOTIFICATION);
//        NotificationCompat.Builder notificationBuilder =
//                new NotificationCompat.Builder(this, channelId)
//                        .setSmallIcon(R.mipmap.ic_launcher)//drawable.splash)
//                        .setContentTitle("Service test")
//                        .setContentText(messageBody)
//                        .setAutoCancel(true)
//                        .setSound(defaultSoundUri)
//                        .setPriority(Notification.PRIORITY_HIGH)
//                        .setContentIntent(pendingIntent);
//
//        NotificationManager notificationManager = (NotificationManager) getSystemService(Context.NOTIFICATION_SERVICE);
//
//        // Since android Oreo notification channel is needed.
//        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
//            NotificationChannel channel = new NotificationChannel(channelId,"Channel human readable title", NotificationManager.IMPORTANCE_DEFAULT);
//            notificationManager.createNotificationChannel(channel);
//        }
//
//        notificationManager.notify(0 /* ID of notification */, notificationBuilder.build());
//    }
}